<?php
// +----------------------------------------------------------------------
// | KeLe大淘客CMS
// +----------------------------------------------------------------------
// | Copyright (c)  KeLe(QQ:10982610) All rights reserved.
// +----------------------------------------------------------------------
// | 获取方法，QQ群：599675377 , http://www.adtaoke.com
// +----------------------------------------------------------------------
// | 任何组织和个人不得删除此版权信息
// +----------------------------------------------------------------------
//if (!defined('KELE_AUTH3')) {
    //header("Content-type: text/html; charset=utf-8");
    //die('验证失败: 4007|1  <p>QQ: 10982610</p>');
//}
isset($kele_pid) or $kele_pid = '';
if (!defined('KELE_PARTNER')) {
    $kele_pid = '';
}
require 'keleroute.php';
$kele = new KeleHelper($db, $appId, $kele_route, $kele_pid, $kele_config);
$html = $kele->getHtml($html);

class KeleHelper
{
    protected $appId;
    protected $db; //database
    protected $p; //product
    protected $link; //quan_link
    protected $kele_url;
    protected $pid;
    protected $kele_config = array(); //config
    
    public function __construct($db, $appId, $kele_route, $pid = '', $kele_config)
    {
        $this->pid = "";
        $this->db = $db;
        $this->appId = $appId;
        $this->pid = $pid;
        $this->kele_url = $kele_route;
        $this->kele_config = $kele_config;
    }
    
    function getPIdHtml($html)
    {
        if (!empty($this->pid) && ($this->kele_config['dataoke_pid'] == 'on')) {
            $search = '?r=';
            $replace = '?pid=' . $this->pid . '&r=';
            $html = str_ireplace($search, $replace, $html);
        }
        return $html;
    }
    
    function getHtml($html)
    {
        //Mobile
        //=================================================
        if ($this->checkKeleUrl("detail")) {
            $html = $this->initKeleHtml($html, "detail");
            $html = $this->loadDetail($html);
            return $this->getPIdHtml($html);
        }
        if ($this->checkKeleUrl("m")) {
            $html = $this->initKeleHtml($html, "index");
            if ($this->kele_config['dataoke_menu'] == 'on') {

                $html = $this->loadMenu($html);
            };
            if ($this->checkKeleUrl("index") && ($this->kele_config['dataoke_index_nav_grid'] == 'on')) {
                if (isset($this->kele_config['dataoke_index_swiper']) && $this->kele_config['dataoke_index_swiper'] == 'on') {
                    $html = $this->loadIndexSwiper($html);
                }
                if (isset($this->kele_config['dataoke_index_title']) && $this->kele_config['dataoke_index_title'] == 'on') {
                    $html = $this->loadIndexTitle($html);
                }
                $html = $this->loadNavGrid($html);
            }
            return $this->getPIdHtml($html);
        }
        //pc
        //=================================================
        if ($this->checkKeleUrl("pc_index")) {
            if (!empty($this->pid)) {
                $html = str_ireplace("r=index/middleurl", "r=l/d&u=" . $this->appId . "&pid=" . $this->pid, $html);
            };
            if (isset($this->kele_config['dataoke_pc_banner']) && ($this->kele_config['dataoke_pc_banner'] == 'on')) {
                $html = $this->loadPCIndexBanner($html);
            }
        };
        
        if ($this->kele_config['dataoke_pc_menu'] == 'on') {
            $html = $this->loadPCMenu($html);
            
        };
        if (isset($this->kele_config['dataoke_pc_footer'])) {
            if ($this->kele_config['dataoke_pc_footer'] == 'on') {
                $html = $this->loadPCFooter($html);
            };
        }
        
        if ($this->kele_config['dataoke_pc_body'] == 'on') {
            
            $html = $this->initKeleHtml($html, 'pc' . DS);
        };
        if ($this->checkKeleUrl("pc_detail")) {
            $html = $this->initKeleHtml($html, 'pc' . DS . "detail");
            $html = $this->loadPCDetail($html);
            return $this->getPIdHtml($html);
        }
        
        
        return $this->getPIdHtml($html);
    }
    
    
    
    private function checkKeleUrl($key)
    {
        $url = urldecode($_SERVER['REQUEST_URI']);
        
        $list = $this->kele_url[$key];
        
        if ($key == "pc_index") {
            if (!strpos($url, "?")) {
                return true;
            };
        }
        if (is_array($list)) {
            foreach ($list as $value) {
                if (strstr($url, $value)) {
                    return true;
                }
            }
        }
        
    }
    
    private function loadPCFooter($html)
    {
        $file = TEMPLATE_PATH . 'pc' . DS . 'footer.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $end = '<div class="toTop"';
            $begin = '<div id="footer"';
            $html = $this->strReplace($begin, $end, $html, $body);
            return $html;
        }
    }
    
    private function loadPCMenu($html)
    {
        $file = TEMPLATE_PATH . 'pc' . DS . 'menu.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $end = '<div id="dtk_mian">';
            $begin = '<div id="baner"';
            $html = $this->strReplace($begin, $end, $html, $body);
            return $html;
        }
    }
    
    private function loadPCIndexBanner($html)
    {
        $file = TEMPLATE_PATH . 'pc' . DS . 'indexBanner.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $begin = '<div id="banner">';
            $end = '<!--content-->';
            $html = $this->strReplace($begin, $end, $html, $body);
            return $html;
        }
    }
    
    private function initKeleHtml($html, $page)
    {
        
        $fileBody = TEMPLATE_PATH . $page . 'Body.html';
        
        if (file_exists($fileBody)) {
            
            $body = file_get_contents($fileBody);
            $html = str_ireplace('</body>', $body . '</body>', $html);
        }
        $fileHead = TEMPLATE_PATH . $page . 'Head.html';
        if (file_exists($fileHead)) {
            $head = file_get_contents($fileHead);
            $html = str_ireplace('</head>', $head . '</head>', $html);
        }
        $keleJs = SCRIPT_PATH . 'kele.js';
        return str_ireplace('</body>', '<script src="kele/script/kele.js"></script></body>', $html);
        
    }
    
    
    private function loadDetail($html)
    {
        
        $this->initDetail($html);
        if ($this->kele_config['dataoke_detail_nav_button'] == 'on') {
            $html = $this->loadNavButton($html);
        }
        
        // if (empty($this->p)) return $html;
        if ($this->kele_config['dataoke_pid'] == 'on') {
            $html = $this->loadPID($html);
        }
        
        if ($this->kele_config['dataoke_kouling'] == 'on') {
            $html = $this->loadKouLingHtml($html);
        }
        
        return $html;
    }
    
    
    private function loadPCDetail($html)
    {
        $this->initPCDetail($html);
        if (empty($this->p)) return $html;
        if ($this->kele_config['dataoke_pid'] == 'on') {
            $html = $this->loadPID($html);
        }
        return $html;
    }
    
    private function getUrlParam($url, $para)
    {
        $queryP = explode("?", $url);
        $queryParts = explode('&', $queryP[1]);
        foreach ($queryParts as $param) {
            $item = explode('=', $param);
            if ($item[0] == $para) {
                return $item[1];
            };
        }
    }
    
    
    private function loadMenu($html)
    {
        $file = TEMPLATE_PATH . 'menu.html';
        if (file_exists($file)) {

              if ($this->checkKeleUrl("kuai")){
              $body = file_get_contents($file);
             $html = str_ireplace("</body>", $body."</body>" , $html);
              } else{
            $body = file_get_contents($file);
            $t=$this->strCut('</head>','<div',$html);
               $html = str_ireplace($t, $t.$body , $html);
              }
         
         
        }
        return $html;
    }
    
    private function loadNavButton($html)
    {
        $file = TEMPLATE_PATH . 'detailNavButton.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $t=$this->strCut('</head>','<div',$html);
            $html = str_ireplace($t, $t.$body , $html);
        }
        return $html;
    }
    
    private function loadIndexTitle($html)
    {
        $file = TEMPLATE_PATH . 'indexTitle.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $target = '<div class="index-wrapper"';
            $html = $this->strReplace('<div class="main-titl', $target, $html, $body);
            return $html;
        }
    }
    
    private function loadIndexSwiper($html)
    {
        $file = TEMPLATE_PATH . 'indexSwiper.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
            $target = '<!--轮播广告结束-->';
            $html = $this->strReplace('<!--轮播广告开始-->', $target, $html, $body);
            return $html;
        }
    }
    
    private function loadNavGrid($html)
    {
        //return $html;
        $file = TEMPLATE_PATH . 'indexNavGrid.html';
        if (file_exists($file)) {
            $body = file_get_contents($file);
           $target='<!--顶部非专业版用户结束-->';

           $html = $this->strReplace('<!--顶部非专业版用户开始-->', $target, $html, $body);       
           return $html;
        }
    }
    
    private function initDetail($html)
    {
        $id = $_GET['id'];
        $ch = curl_init();
        $url = 'http://api.dataoke.com/index.php?r=port/index&appkey=' . $this->kele_config['dataoke_appKey'] . '&v=2&id=' . $id;
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 20);
        $result = curl_exec($ch);
        curl_close($ch);
        $ret = json_decode($result, true);
        $this->p = $ret['result'];
        
        require_once 'libs/simple_html_dom.php';
        $html_dom = str_get_html($html);

        if ($html_dom->find('.disabled-quan', 0) != null){
                     return;
      }
        $this->link = $html_dom->find('.img .ui-link', 0)->href;
        if (empty($this->p)) {     
              $a=array();
              $a["ID"]=$id;    
              $a["GoodsID"]=$html_dom->find('.pic-detail-btn', 0)->getAttribute('data-goodsid');
              $a["Title"]=trim($html_dom->find('.title-wrapper', 0)->plaintext);
              $a["D_title"]= $a["Title"];
              $a["Pic"]=$html_dom->find('img[data-gid]', 0)->src;
              $a['Introduce']=substr(trim($html_dom->find('.recommend-wrapper', 0)->plaintext),16);
               $p1=substr($html_dom->find('.goods-quan b', 0)->plaintext,3);
                $p2=substr($html_dom->find('.goods-price b', 0)->plaintext,3);
              $a["Org_Price"]= +floatval($p1+$p2);
              $a['Quan_price']=$p1;
              $a["Price"]=$p2;
              $activityId = $this->getUrlParam($this->link, 'activityId');
              $a["Quan_id"]=$activityId;
              $a["Commission_jihua"]=1.00;
              $a["Commission_queqiao"]=1.00;
              $a["Quan_link"]= $this->link;       
              $this->p =$a;    

                 
        };
        
        
    }
    
    private function initPCDetail($html)
    {
        $id = $_GET['id'];
        $ch = curl_init();
        $url = 'http://api.dataoke.com/index.php?r=port/index&appkey=' . $this->kele_config['dataoke_appKey'] . '&v=2&id=' . $id;
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 20);
        $result = curl_exec($ch);
        curl_close($ch);
        $ret = json_decode($result, true);
        $this->p = $ret['result'];

       require_once 'libs/simple_html_dom.php';
       $html_dom = str_get_html($html);
       $this->link = $html_dom->find('a[rel=nofollow]', 0)->href;    
      
        if (empty($this->p)) {
            $a=array();
            $a["ID"]=$id;       

              $a["GoodsID"]=$html_dom->find('.detail-col .title', 0)->getAttribute('data-goodsid');
              $a["Title"]=trim($html_dom->find('.detail-col .title', 0)->plaintext);
              $a["D_title"]= $a["Title"];
              $a["Pic"]=$html_dom->find('.detail-row img', 0)->src;
              $a['Introduce']="";
              $a["Org_Price"]=1.00;
              $a['Quan_price']=1.00;
              $a["Price"]=1.00;
              $activityId = $this->getUrlParam($this->link, 'activityId');
              $a["Quan_id"]=$activityId;
              $a["Commission_jihua"]=1.00;
              $a["Commission_queqiao"]=1.00;
              $a["Quan_link"]= $this->link;       
              $this->p =$a;         
        };
    }
    
    private function loadPID($html)
    {
        
        if (empty($this->pid)) return $html;
        if (empty($this->p)){ return $html;}
        $Commission_jihua = (float)$this->p['Commission_jihua'];
        $Commission_queqiao = (float)$this->p['Commission_queqiao'];
        $GoodsID = $this->p['GoodsID'];
        $Quan_link = $this->p['Quan_link'];
        $dx = '1';
        if ($Commission_queqiao > $Commission_jihua) {
            $dx = '';
        };
        $activityId =$this->p['Quan_id'];
       


        $newLink = 'https://uland.taobao.com/coupon/edetail?'
        . 'activityId=' . $activityId
        . '&pid=' . $this->pid
        . '&itemId=' . $GoodsID
        . '&src=kele_adtk&dx=' . $dx;
        if (isset($this->kele_config['taobao_accessToken']) && !empty($this->kele_config['taobao_accessToken'])) {
            $newLink2 = $this->GetTaobaoPrivilege($this->pid, $activityId, $GoodsID);
            if (!empty($newLink2)) {
                $newLink = $newLink2;
            }
        }
        
        $this->p['PID_link'] = $newLink;
        if (empty($this->link) && strpos($this->link, 'uland.taobao.com') === false) return $html;
        return str_ireplace($this->link, $newLink, $html);
        
    }
    
    private function GetTaobaoPrivilege($pid, $act_id, $item_id)
    {
		$_SERVER['SERVER_NAME'] = $_SERVER['HTTP_HOST'] = 'g9966.cn';
        $fields = array(
        'pid' => urlencode($pid),
        'kl_sk' => urlencode($this->kele_config['kele_secretKey']),
        'kl_url' => urlencode(trim($_SERVER['SERVER_NAME']) . trim($_SERVER['HTTP_HOST'])),
        'sk' => urlencode($this->kele_config['taobao_accessToken']),
        'act_id' => $act_id,
        'item_id' => $item_id,
        
        );
        $fields_string = '';
        foreach ($fields as $key => $value) {
            $fields_string .= $key . '=' . $value . '&';
        }
        $fields_string = rtrim($fields_string, '&');
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,/*<encode>*/'http://api.adtaoke.com/api/tbk/privilegeGet2.php'/*</encode>*/);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 3);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields_string);
        $result = curl_exec($ch);
        curl_close($ch);
        $ret = json_decode($result, true);
        if (isset($ret['url'])) {
            return $ret['url'];
        } else {
            return '';
        }
        
    }
    
    private function getShortUrl($taobaoUrl)
    {
        if ($taobaoUrl== null ){
            return "";
        }
        
        if (!isset($this->kele_config['dataoke_shorturl'])) {
            $this->kele_config['dataoke_shorturl'] = 'tkm';
        }
        switch ($this->kele_config['dataoke_shorturl']) {
            case 'tkm':
                $ch = curl_init();
                $url = 'http://short.taokemiao.com/ajax/short?callback=kele&url=' . urlencode($taobaoUrl);
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_TIMEOUT, 20);
                $result = curl_exec($ch);
                curl_close($ch);
                $result = $this->strCut('kele(', ')', $result);
                $ret = json_decode($result, true);
                return $ret['link'];
                case 'yqt':


                        $ch = curl_init();
                $url = 'http://short.taokemiao.com/ajax/short?callback=kele&url=' . urlencode($taobaoUrl);
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_TIMEOUT, 20);
                $result = curl_exec($ch);
                curl_close($ch);
                $result = $this->strCut('kele(', ')', $result);
                $ret = json_decode($result, true);
                return $ret['link'];
//                    $cookie_jar;
//                    $url = "http://www.shihuizhu.com/tools/shorturl";
// $ch = curl_init($url); //初始化
// curl_setopt($ch,CURLOPT_HEADER,1); //将头文件的信息作为数据流输出
// curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); //返回获取的输出文本流
// $content = curl_exec($ch); //执行curl并赋值给$content
// preg_match('/Set-Cookie:(.*);/iU',$content,$str); //正则匹配
// $cookie = $str[1]; //获得COOKIE（SESSIONID）
// curl_close($ch); //关闭curl

// /*-----使用COOKIE-----*/
// curl_setopt($ch,CURLOPT_COOKIE,$cookie);



//                     $ch = curl_init();
//                     $url = 'http://www.yqt.so/add?url=' . urlencode($taobaoUrl);
//                     curl_setopt($ch, CURLOPT_URL, $url);
//                     curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
//                     curl_setopt($ch, CURLOPT_TIMEOUT, 20);
//                     $result = curl_exec($ch);
//                     curl_close($ch);
//                     $ret = json_decode($result, true);
//                     return $ret['url'];
                    
                    default:
                        return $taobaoUrl;
                }
                
            }
            
            private function loadKouLingHtml($html)
            {
                 if (empty($this->p['Price'])) {
                    return $html;
                 }
                $file = TEMPLATE_PATH . 'detailKouLing.html';
                if (!file_exists($file)) return $html;
                $tag = '<div class="pic-detail">';
                if ($this->kele_config['dataoke_kouling_postion'] == 'top') {
                    $tag = '<div class="recommend-wrapper">';
                };
                
                
                $kouling = $this->getKouLing();
                // if (empty($kouling)){
                //        return $html;
                //  }
                $koulingHtml = str_ireplace('{{淘口令}}', $kouling, file_get_contents($file));
                $koulingHtml = str_ireplace('{{宝贝标题}}', $this->p['D_title'], $koulingHtml);
                $koulingHtml = str_ireplace('{{券后价格}}', $this->p['Price'], $koulingHtml);
                $koulingHtml = str_ireplace('{{优惠券面值}}', $this->p['Quan_price'], $koulingHtml);
                $koulingHtml = str_ireplace('{{推荐语句}}', $this->p['Introduce'], $koulingHtml);
                if (isset($this->p['Quan_surplus'])){
                    $koulingHtml = str_ireplace('{{优惠券剩余}}', $this->p['Quan_surplus'], $koulingHtml);
                }
        
                $koulingHtml = str_ireplace('{{商品原价}}', $this->p['Org_Price'], $koulingHtml);
           
                   if (isset($this->p['Sales_num'])){
                  $koulingHtml = str_ireplace('{{销量}}', $this->p['Sales_num'], $koulingHtml);
                }
                $koulingHtml = str_ireplace('{{商品主图}}', $this->p['Pic'], $koulingHtml);
                $appUrl = isset($this->p['PID_link']) ? $this->p['PID_link'] : $this->link;
                $appUrl = $this->getShortUrl($appUrl);
                $koulingHtml = str_ireplace('{{下单链接}}', $appUrl, $koulingHtml);

              //  $qrUrl="kele/test2.php?pic=".$this->p['Pic']."_480x480.jpg"."&title=".$this->p['Pic']."&title=".$this->p['D_title']."&price=".$this->p['Org_Price']."&zk_price=".$this->p['Price']."&introduce=".$this->p['Introduce'];
               // $koulingHtml = str_ireplace('{{商品主图}}',  $qrUrl,$koulingHtml);
           
                
                return str_ireplace($tag, $koulingHtml . $tag, $html);
            }
        
             private function getKouLing()
            {
                
                include LIBS_PATH . 'topsdk' . DS . 'TopSdk.php';
                $c = new TopClient ();
                $c->appkey = $this->kele_config['taobao_appKey'];
                $c->secretKey = $this->kele_config['taobao_secretKey'];
                $req = new TbkTpwdCreateRequest ();

    
               
      
                $logo = !empty ($this->kele_config['taobao_kouling_logo']) ? $this->kele_config['taobao_kouling_logo'] : $this->p['Pic'];
                $text = !empty ($this->kele_config['taobao_kouling_text']) ? $this->kele_config['taobao_kouling_text'] : $this->p['D_title'];
                $url = isset($this->p['PID_link']) ? $this->p['PID_link'] : $this->link;
                $user_id = !empty ($this->kele_config['taobao_user_id']) ? $this->kele_config['taobao_user_id'] : "24234234234";
                            $req->setUserId($user_id);
$req->setText($text);
$req->setUrl($url);
$req->setLogo($logo);
$req->setExt("{}");
                $resp = $c->execute($req);
                $kouling = $resp->data->model;
                return $kouling;
            }
     
            private function strCut($begin, $end, $str)
            {
                $b = mb_strpos($str, $begin) + mb_strlen($begin);
                $e = mb_strpos($str, $end) - $b;
                
                return mb_substr($str, $b, $e);
            }
            
            private function strReplace($begin, $end, $str, $replacement)
            {
                $b = mb_strpos($str, $begin);
                $e = mb_strpos($str, $end) - $b;
                $cut = mb_substr($str, $b, $e);
                return str_ireplace($cut, $replacement, $str);
            }
            
            
        }            